#!/usr/bin/env python
import re
import sys
import os
#\TOCentry[Biondo Biondi]{Measuring image focusing for velocity analysis}{\pagere

def build_list():
  list={}
  srch=re.compile(".+TOCentry\[(.+)\]{(.+)}{.+$")
  f=open("toc.tex")
  lines=f.readlines()
  for line in lines:
    x=srch.search(line)
    if x:
      list[x.group(2)]=x.group(1)
  return list

def build_entry(title,author,year,rep,map,count):
  authors=author.split(" and ")
  main=authors[0].lstrip().rstrip()
  name=main.split()
  last=name[len(name)-1]
  if not count.has_key(last): 
    count[last]=0
  count[last]=count[last]+1
  if not map.has_key(title):
    map[title]="DIDNOT WORK"
  x="%s.sep.%s.%s"%(last,rep,map[title])
  print "@SEPREPORT{%s,"%x
  print "  author={%s},"%author
  print "  title={ %s },"%title
  print "  pages={X--Y},"
  print "  organization={SEP},"
  print "  year={%s},"%year
  print "  journal={SEP-Report},"
  print "  volume={%s},"%rep
  print "  url={http://sepwww.stanford.edu/public/docs/sep%s}"%rep
  print "}"
  print " "
  return count

findit=re.compile("title{(.+)}")

dirs={}
for subdirname in os.listdir("."):
       if os.path.exists("%s/paper.tex"%subdirname):
         f=open("%s/paper.tex"%subdirname)
         lines=f.readlines()       
         for line in lines:
           x=findit.search(line)
           if x:
             dirs[x.group(1)]=subdirname
         f.close()

print dirs

year=sys.argv[1]
rep=sys.argv[2]
list=build_list()
count={}
for key,val in list.items():
  count=  build_entry(key,val,year,rep,dirs,count)
