//Following musa1 in sep150
#include <cstdio>
#include <cstdlib>
#include "mylib.h"
#include "myio.h"
#include "wave.h"
#include "solvers.h"

void nlcg0(float *c11,float *c13,float *c33,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *g=new float[niter]();

 float *gc11=new float[nnx*nnz]();
 float *gc13=new float[nnx*nnz]();
 float *gc33=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient0(gc11,gc13,gc33,d0,c11,c13,c33,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
 
 g[0]=dot_product(gc11,gc11,nnx*nnz)+dot_product(gc13,gc13,nnx*nnz)+dot_product(gc33,gc33,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pc11=new float[nnx*nnz](); mynegate(pc11,gc11,nnx*nnz);
 float *pc13=new float[nnx*nnz](); mynegate(pc13,gc13,nnx*nnz);
 float *pc33=new float[nnx*nnz](); mynegate(pc33,gc33,nnx*nnz);
 
 write("ic11",c11,nnx*nnz);
 write("ic13",c13,nnx*nnz);
 write("ic33",c33,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ic11","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic11","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic11","n3",niter,"o3",0.,"d3",1.);
 to_header("ic13","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic13","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic13","n3",niter,"o3",0.,"d3",1.);
 to_header("ic33","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic33","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic33","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggc11=new float[nnx*nnz]();
 float *ggc13=new float[nnx*nnz]();
 float *ggc33=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pc11,gc11,nnx*nnz)+dot_product(pc13,gc13,nnx*nnz)+dot_product(pc33,gc33,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pc11,gc11,nnx*nnz);
   mynegate(pc13,gc13,nnx*nnz);
   mynegate(pc33,gc33,nnx*nnz);
  }

  float a=line_search0(c11,c13,c33,f[iter],ggc11,ggc13,ggc33,f[iter-1],gc11,gc13,gc33,pc11,pc13,pc33,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggc11,ggc11,nnx*nnz)+dot_product(ggc13,ggc13,nnx*nnz)+dot_product(ggc33,ggc33,nnx*nnz);
  
  float temp=dot_product(ggc11,gc11,nnx*nnz)+dot_product(ggc13,gc13,nnx*nnz)+dot_product(ggc33,gc33,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pc11,-1.,ggc11,b,pc11,nnx*nnz); 
  lin_comb(pc13,-1.,ggc13,b,pc13,nnx*nnz); 
  lin_comb(pc33,-1.,ggc33,b,pc33,nnx*nnz); 

  float *pt;
  pt=gc11;gc11=ggc11;ggc11=pt;
  pt=gc13;gc13=ggc13;ggc13=pt;
  pt=gc33;gc33=ggc33;ggc33=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ic11",c11,nnx*nnz,std::ios_base::app);
  write("ic13",c13,nnx*nnz,std::ios_base::app);
  write("ic33",c33,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []g;
 delete[] m;
 delete []gc11;delete []gc13;delete []gc33;
 delete []pc11;delete []pc13;delete []pc33;
 delete []ggc11;delete []ggc13;delete []ggc33;
 return;
}

void nlcg01(float *c11,float *c13,float *c33,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gc11=new float[nnx*nnz]();
 float *gc13=new float[nnx*nnz]();
 float *gc33=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient01(datafit[0],reg,gc11,gc13,gc33,d0,c11,c13,c33,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gc11,gc11,nnx*nnz)+dot_product(gc13,gc13,nnx*nnz)+dot_product(gc33,gc33,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pc11=new float[nnx*nnz](); mynegate(pc11,gc11,nnx*nnz);
 float *pc13=new float[nnx*nnz](); mynegate(pc13,gc13,nnx*nnz);
 float *pc33=new float[nnx*nnz](); mynegate(pc33,gc33,nnx*nnz);
 
 write("ic11",c11,nnx*nnz);
 write("ic13",c13,nnx*nnz);
 write("ic33",c33,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ic11","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic11","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic11","n3",niter,"o3",0.,"d3",1.);
 to_header("ic13","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic13","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic13","n3",niter,"o3",0.,"d3",1.);
 to_header("ic33","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic33","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic33","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggc11=new float[nnx*nnz]();
 float *ggc13=new float[nnx*nnz]();
 float *ggc33=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pc11,gc11,nnx*nnz)+dot_product(pc13,gc13,nnx*nnz)+dot_product(pc33,gc33,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pc11,gc11,nnx*nnz);
   mynegate(pc13,gc13,nnx*nnz);
   mynegate(pc33,gc33,nnx*nnz);
  }

  float a=line_search01(c11,c13,c33,f[iter],datafit[iter],ggc11,ggc13,ggc33,f[iter-1],gc11,gc13,gc33,pc11,pc13,pc33,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggc11,ggc11,nnx*nnz)+dot_product(ggc13,ggc13,nnx*nnz)+dot_product(ggc33,ggc33,nnx*nnz);
  
  float temp=dot_product(ggc11,gc11,nnx*nnz)+dot_product(ggc13,gc13,nnx*nnz)+dot_product(ggc33,gc33,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pc11,-1.,ggc11,b,pc11,nnx*nnz); 
  lin_comb(pc13,-1.,ggc13,b,pc13,nnx*nnz); 
  lin_comb(pc33,-1.,ggc33,b,pc33,nnx*nnz); 

  float *pt;
  pt=gc11;gc11=ggc11;ggc11=pt;
  pt=gc13;gc13=ggc13;ggc13=pt;
  pt=gc33;gc33=ggc33;ggc33=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ic11",c11,nnx*nnz,std::ios_base::app);
  write("ic13",c13,nnx*nnz,std::ios_base::app);
  write("ic33",c33,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gc11;delete []gc13;delete []gc33;
 delete []pc11;delete []pc13;delete []pc33;
 delete []ggc11;delete []ggc13;delete []ggc33;
 return;
}

void nlcg1(float *v,float *eps,float *del,float v0,float eps0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *geps=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();
 
 f[0]=objFuncGradient1(gv,geps,gdel,d0,v,eps,del,v0,eps0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(geps,geps,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pv=new float[nnx*nnz](); mynegate(pv,gv,nnx*nnz);
 float *peps=new float[nnx*nnz](); mynegate(peps,geps,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,gdel,nnx*nnz);
  
 write("iv",v,nnx*nnz);
 write("ieps",eps,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ieps","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieps","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieps","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggeps=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();
 
 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(peps,geps,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pv,gv,nnx*nnz);
   mynegate(peps,geps,nnx*nnz);
   mynegate(pdel,gdel,nnx*nnz);
  }

  float a=line_search1(v,eps,del,f[iter],ggv,ggeps,ggdel,f[iter-1],gv,geps,gdel,pv,peps,pdel,v0,eps0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggeps,ggeps,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  float temp=dot_product(ggv,gv,nnx*nnz)+dot_product(ggeps,geps,nnx*nnz)+dot_product(ggdel,gdel,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pv,-1.,ggv,b,pv,nnx*nnz); 
  lin_comb(peps,-1.,ggeps,b,peps,nnx*nnz); 
  lin_comb(pdel,-1.,ggdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=geps;geps=ggeps;ggeps=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ieps",eps,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []g;
 delete[] m;
 delete []gv;delete []geps;delete []gdel;
 delete []pv;delete []peps;delete []pdel;
 delete []ggv;delete []ggeps;delete []ggdel;
 return;
}

void nlcg11(float *v,float *eps,float *del,float v0,float eps0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *geps=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();
 
 f[0]=objFuncGradient11(datafit[0],reg,gv,geps,gdel,d0,v,eps,del,v0,eps0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(geps,geps,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pv=new float[nnx*nnz](); mynegate(pv,gv,nnx*nnz);
 float *peps=new float[nnx*nnz](); mynegate(peps,geps,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,gdel,nnx*nnz);
  
 write("iv",v,nnx*nnz);
 write("ieps",eps,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ieps","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieps","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieps","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggeps=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();
 
 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, datafit %f, grad2 %f\n",iter,f[iter-1],datafit[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(peps,geps,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pv,gv,nnx*nnz);
   mynegate(peps,geps,nnx*nnz);
   mynegate(pdel,gdel,nnx*nnz);
  }

  float a=line_search11(v,eps,del,f[iter],datafit[iter],ggv,ggeps,ggdel,f[iter-1],gv,geps,gdel,pv,peps,pdel,v0,eps0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggeps,ggeps,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  float temp=dot_product(ggv,gv,nnx*nnz)+dot_product(ggeps,geps,nnx*nnz)+dot_product(ggdel,gdel,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pv,-1.,ggv,b,pv,nnx*nnz); 
  lin_comb(peps,-1.,ggeps,b,peps,nnx*nnz); 
  lin_comb(pdel,-1.,ggdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=geps;geps=ggeps;ggeps=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ieps",eps,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gv;delete []geps;delete []gdel;
 delete []pv;delete []peps;delete []pdel;
 delete []ggv;delete []ggeps;delete []ggdel;
 return;
}

void nlcg2(float *vn,float *eta,float *del,float vn0,float eta0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *g=new float[niter]();

 float *gvn=new float[nnx*nnz]();
 float *geta=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();
 
 f[0]=objFuncGradient2(gvn,geta,gdel,d0,vn,eta,del,vn0,eta0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
 
 g[0]=dot_product(gvn,gvn,nnx*nnz)+dot_product(geta,geta,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pvn=new float[nnx*nnz](); mynegate(pvn,gvn,nnx*nnz);
 float *peta=new float[nnx*nnz](); mynegate(peta,geta,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,gdel,nnx*nnz);
  
 write("ivn",vn,nnx*nnz);
 write("ieta",eta,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ieta","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieta","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieta","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvn=new float[nnx*nnz]();
 float *ggeta=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();
 
 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvn,gvn,nnx*nnz)+dot_product(peta,geta,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pvn,gvn,nnx*nnz);
   mynegate(peta,geta,nnx*nnz);
   mynegate(pdel,gdel,nnx*nnz);
  }

  float a=line_search2(vn,eta,del,f[iter],ggvn,ggeta,ggdel,f[iter-1],gvn,geta,gdel,pvn,peta,pdel,vn0,eta0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggeta,ggeta,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  float temp=dot_product(ggvn,gvn,nnx*nnz)+dot_product(ggeta,geta,nnx*nnz)+dot_product(ggdel,gdel,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pvn,-1.,ggvn,b,pvn,nnx*nnz); 
  lin_comb(peta,-1.,ggeta,b,peta,nnx*nnz); 
  lin_comb(pdel,-1.,ggdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=geta;geta=ggeta;ggeta=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ieta",eta,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []g;
 delete[] m;
 delete []gvn;delete []geta;delete []gdel;
 delete []pvn;delete []peta;delete []pdel;
 delete []ggvn;delete []ggeta;delete []ggdel;
 return;
}

void nlcg21(float *vn,float *eta,float *del,float vn0,float eta0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gvn=new float[nnx*nnz]();
 float *geta=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient21(datafit[0],reg,gvn,geta,gdel,d0,vn,eta,del,vn0,eta0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gvn,gvn,nnx*nnz)+dot_product(geta,geta,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pvn=new float[nnx*nnz](); mynegate(pvn,gvn,nnx*nnz);
 float *peta=new float[nnx*nnz](); mynegate(peta,geta,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,gdel,nnx*nnz);
 
 write("ivn",vn,nnx*nnz);
 write("ieta",eta,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ieta","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieta","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieta","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvn=new float[nnx*nnz]();
 float *ggeta=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvn,gvn,nnx*nnz)+dot_product(peta,geta,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pvn,gvn,nnx*nnz);
   mynegate(peta,geta,nnx*nnz);
   mynegate(pdel,gdel,nnx*nnz);
  }

  float a=line_search21(vn,eta,del,f[iter],datafit[iter],ggvn,ggeta,ggdel,f[iter-1],gvn,geta,gdel,pvn,peta,pdel,vn0,eta0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggeta,ggeta,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  float temp=dot_product(ggvn,gvn,nnx*nnz)+dot_product(ggeta,geta,nnx*nnz)+dot_product(ggdel,gdel,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pvn,-1.,ggvn,b,pvn,nnx*nnz); 
  lin_comb(peta,-1.,ggeta,b,peta,nnx*nnz); 
  lin_comb(pdel,-1.,ggdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=geta;geta=ggeta;ggeta=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ieta",eta,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gvn;delete []geta;delete []gdel;
 delete []pvn;delete []peta;delete []pdel;
 delete []ggvn;delete []ggeta;delete []ggdel;
 return;
}

void nlcg3(float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *g=new float[niter]();

 float *gvh=new float[nnx*nnz]();
 float *geps=new float[nnx*nnz]();
 float *geta=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();
 
 f[0]=objFuncGradient3(gvh,geps,geta,d0,vh,eps,eta,vh0,eps0,eta0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
 
 g[0]=dot_product(gvh,gvh,nnx*nnz)+dot_product(geps,geps,nnx*nnz)+dot_product(geta,geta,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pvh=new float[nnx*nnz](); mynegate(pvh,gvh,nnx*nnz);
 float *peps=new float[nnx*nnz](); mynegate(peps,geps,nnx*nnz);
 float *peta=new float[nnx*nnz](); mynegate(peta,geta,nnx*nnz);
  
 write("ivh",vh,nnx*nnz);
 write("ieps",eps,nnx*nnz);
 write("ieta",eta,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("ieps","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieps","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieps","n3",niter,"o3",0.,"d3",1.);
 to_header("ieta","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieta","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieta","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvh=new float[nnx*nnz]();
 float *ggeps=new float[nnx*nnz]();
 float *ggeta=new float[nnx*nnz]();
 
 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvh,gvh,nnx*nnz)+dot_product(peps,geps,nnx*nnz)+dot_product(peta,geta,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pvh,gvh,nnx*nnz);
   mynegate(peps,geps,nnx*nnz);
   mynegate(peta,geta,nnx*nnz);
  }

  float a=line_search3(vh,eps,eta,f[iter],ggvh,ggeps,ggeta,f[iter-1],gvh,geps,geta,pvh,peps,peta,vh0,eps0,eta0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggeps,ggeps,nnx*nnz)+dot_product(ggeta,ggeta,nnx*nnz);
  
  float temp=dot_product(ggvh,gvh,nnx*nnz)+dot_product(ggeps,geps,nnx*nnz)+dot_product(ggeta,geta,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pvh,-1.,ggvh,b,pvh,nnx*nnz); 
  lin_comb(peps,-1.,ggeps,b,peps,nnx*nnz); 
  lin_comb(peta,-1.,ggeta,b,peta,nnx*nnz); 

  float *pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=geps;geps=ggeps;ggeps=pt;
  pt=geta;geta=ggeta;ggeta=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("ieps",eps,nnx*nnz,std::ios_base::app);
  write("ieta",eta,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []g;
 delete[] m;
 delete []gvh;delete []geps;delete []geta;
 delete []pvh;delete []peps;delete []peta;
 delete []ggvh;delete []ggeps;delete []ggeta;
 return;
}

void nlcg31(float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gvh=new float[nnx*nnz]();
 float *geps=new float[nnx*nnz]();
 float *geta=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient31(datafit[0],reg,gvh,geps,geta,d0,vh,eps,eta,vh0,eps0,eta0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gvh,gvh,nnx*nnz)+dot_product(geps,geps,nnx*nnz)+dot_product(geta,geta,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pvh=new float[nnx*nnz](); mynegate(pvh,gvh,nnx*nnz);
 float *peps=new float[nnx*nnz](); mynegate(peps,geps,nnx*nnz);
 float *peta=new float[nnx*nnz](); mynegate(peta,geta,nnx*nnz);
 
 write("ivh",vh,nnx*nnz);
 write("ieps",eps,nnx*nnz);
 write("ieta",eta,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("ieps","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieps","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieps","n3",niter,"o3",0.,"d3",1.);
 to_header("ieta","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieta","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieta","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvh=new float[nnx*nnz]();
 float *ggeps=new float[nnx*nnz]();
 float *ggeta=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvh,gvh,nnx*nnz)+dot_product(peps,geps,nnx*nnz)+dot_product(peta,geta,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pvh,gvh,nnx*nnz);
   mynegate(peps,geps,nnx*nnz);
   mynegate(peta,geta,nnx*nnz);
  }

  float a=line_search31(vh,eps,eta,f[iter],datafit[iter],ggvh,ggeps,ggeta,f[iter-1],gvh,geps,geta,pvh,peps,peta,vh0,eps0,eta0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggeps,ggeps,nnx*nnz)+dot_product(ggeta,ggeta,nnx*nnz);
  
  float temp=dot_product(ggvh,gvh,nnx*nnz)+dot_product(ggeps,geps,nnx*nnz)+dot_product(ggeta,geta,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pvh,-1.,ggvh,b,pvh,nnx*nnz); 
  lin_comb(peps,-1.,ggeps,b,peps,nnx*nnz); 
  lin_comb(peta,-1.,ggeta,b,peta,nnx*nnz); 

  float *pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=geps;geps=ggeps;ggeps=pt;
  pt=geta;geta=ggeta;ggeta=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("ieps",eps,nnx*nnz,std::ios_base::app);
  write("ieta",eta,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gvh;delete []geps;delete []geta;
 delete []pvh;delete []peps;delete []peta;
 delete []ggvh;delete []ggeps;delete []ggeta;
 return;
}

void nlcg4(float *v,float *vh,float *del,float v0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();
 
 f[0]=objFuncGradient4(gv,gvh,gdel,d0,v,vh,del,v0,vh0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pv=new float[nnx*nnz](); mynegate(pv,gv,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,gvh,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,gdel,nnx*nnz);
  
 write("iv",v,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();
 
 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pv,gv,nnx*nnz);
   mynegate(pvh,gvh,nnx*nnz);
   mynegate(pdel,gdel,nnx*nnz);
  }

  float a=line_search4(v,vh,del,f[iter],ggv,ggvh,ggdel,f[iter-1],gv,gvh,gdel,pv,pvh,pdel,v0,vh0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  float temp=dot_product(ggv,gv,nnx*nnz)+dot_product(ggvh,gvh,nnx*nnz)+dot_product(ggdel,gdel,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pv,-1.,ggv,b,pv,nnx*nnz); 
  lin_comb(pvh,-1.,ggvh,b,pvh,nnx*nnz); 
  lin_comb(pdel,-1.,ggdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []g;
 delete[] m;
 delete []gv;delete []gvh;delete []gdel;
 delete []pv;delete []pvh;delete []pdel;
 delete []ggv;delete []ggvh;delete []ggdel;
 return;
}

void nlcg41(float *v,float *vh,float *del,float v0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient41(datafit[0],reg,gv,gvh,gdel,d0,v,vh,del,v0,vh0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pv=new float[nnx*nnz](); mynegate(pv,gv,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,gvh,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,gdel,nnx*nnz);
 
 write("iv",v,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pv,gv,nnx*nnz);
   mynegate(pvh,gvh,nnx*nnz);
   mynegate(pdel,gdel,nnx*nnz);
  }

  float a=line_search41(v,vh,del,f[iter],datafit[iter],ggv,ggvh,ggdel,f[iter-1],gv,gvh,gdel,pv,pvh,pdel,v0,vh0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  float temp=dot_product(ggv,gv,nnx*nnz)+dot_product(ggvh,gvh,nnx*nnz)+dot_product(ggdel,gdel,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pv,-1.,ggv,b,pv,nnx*nnz); 
  lin_comb(pvh,-1.,ggvh,b,pvh,nnx*nnz); 
  lin_comb(pdel,-1.,ggdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gv;delete []gvh;delete []gdel;
 delete []pv;delete []pvh;delete []pdel;
 delete []ggv;delete []ggvh;delete []ggdel;
 return;
}

void nlcg5(float *vn,float *vh,float *del,float vn0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *g=new float[niter]();

 float *gvn=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();
 
 f[0]=objFuncGradient5(gvn,gvh,gdel,d0,vn,vh,del,vn0,vh0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
 
 g[0]=dot_product(gvn,gvn,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pvn=new float[nnx*nnz](); mynegate(pvn,gvn,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,gvh,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,gdel,nnx*nnz);
  
 write("ivn",vn,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvn=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();
 
 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvn,gvn,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pvn,gvn,nnx*nnz);
   mynegate(pvh,gvh,nnx*nnz);
   mynegate(pdel,gdel,nnx*nnz);
  }

  float a=line_search5(vn,vh,del,f[iter],ggvn,ggvh,ggdel,f[iter-1],gvn,gvh,gdel,pvn,pvh,pdel,vn0,vh0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  float temp=dot_product(ggvn,gvn,nnx*nnz)+dot_product(ggvh,gvh,nnx*nnz)+dot_product(ggdel,gdel,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pvn,-1.,ggvn,b,pvn,nnx*nnz); 
  lin_comb(pvh,-1.,ggvh,b,pvh,nnx*nnz); 
  lin_comb(pdel,-1.,ggdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []g;
 delete[] m;
 delete []gvn;delete []gvh;delete []gdel;
 delete []pvn;delete []pvh;delete []pdel;
 delete []ggvn;delete []ggvh;delete []ggdel;
 return;
}

void nlcg51(float *vn,float *vh,float *del,float vn0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gvn=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient51(datafit[0],reg,gvn,gvh,gdel,d0,vn,vh,del,vn0,vh0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gvn,gvn,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pvn=new float[nnx*nnz](); mynegate(pvn,gvn,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,gvh,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,gdel,nnx*nnz);
 
 write("ivn",vn,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvn=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvn,gvn,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pvn,gvn,nnx*nnz);
   mynegate(pvh,gvh,nnx*nnz);
   mynegate(pdel,gdel,nnx*nnz);
  }

  float a=line_search51(vn,vh,del,f[iter],datafit[iter],ggvn,ggvh,ggdel,f[iter-1],gvn,gvh,gdel,pvn,pvh,pdel,vn0,vh0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  float temp=dot_product(ggvn,gvn,nnx*nnz)+dot_product(ggvh,gvh,nnx*nnz)+dot_product(ggdel,gdel,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pvn,-1.,ggvn,b,pvn,nnx*nnz); 
  lin_comb(pvh,-1.,ggvh,b,pvh,nnx*nnz); 
  lin_comb(pdel,-1.,ggdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gvn;delete []gvh;delete []gdel;
 delete []pvn;delete []pvh;delete []pdel;
 delete []ggvn;delete []ggvh;delete []ggdel;
 return;
}

void nlcg6(float *v,float *vn,float *vh,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *gvn=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();
 
 f[0]=objFuncGradient6(gv,gvn,gvh,d0,v,vn,vh,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(gvn,gvn,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pv=new float[nnx*nnz](); mynegate(pv,gv,nnx*nnz);
 float *pvn=new float[nnx*nnz](); mynegate(pvn,gvn,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,gvh,nnx*nnz);
  
 write("iv",v,nnx*nnz);
 write("ivn",vn,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggvn=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();
 
 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(pvn,gvn,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pv,gv,nnx*nnz);
   mynegate(pvn,gvn,nnx*nnz);
   mynegate(pvh,gvh,nnx*nnz);
  }

  float a=line_search6(v,vn,vh,f[iter],ggv,ggvn,ggvh,f[iter-1],gv,gvn,gvh,pv,pvn,pvh,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz);
  
  float temp=dot_product(ggv,gv,nnx*nnz)+dot_product(ggvn,gvn,nnx*nnz)+dot_product(ggvh,gvh,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pv,-1.,ggv,b,pv,nnx*nnz); 
  lin_comb(pvn,-1.,ggvn,b,pvn,nnx*nnz); 
  lin_comb(pvh,-1.,ggvh,b,pvh,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []g;
 delete[] m;
 delete []gv;delete []gvn;delete []gvh;
 delete []pv;delete []pvn;delete []pvh;
 delete []ggv;delete []ggvn;delete []ggvh;
 return;
}

void nlcg61(float *v,float *vn,float *vh,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *gvn=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient61(datafit[0],reg,gv,gvn,gvh,d0,v,vn,vh,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(gvn,gvn,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *pv=new float[nnx*nnz](); mynegate(pv,gv,nnx*nnz);
 float *pvn=new float[nnx*nnz](); mynegate(pvn,gvn,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,gvh,nnx*nnz);
 
 write("iv",v,nnx*nnz);
 write("ivn",vn,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggvn=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(pvn,gvn,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   mynegate(pv,gv,nnx*nnz);
   mynegate(pvn,gvn,nnx*nnz);
   mynegate(pvh,gvh,nnx*nnz);
  }

  float a=line_search61(v,vn,vh,f[iter],datafit[iter],ggv,ggvn,ggvh,f[iter-1],gv,gvn,gvh,pv,pvn,pvh,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz);
  
  float temp=dot_product(ggv,gv,nnx*nnz)+dot_product(ggvn,gvn,nnx*nnz)+dot_product(ggvh,gvh,nnx*nnz);

  float bPR=(g[iter]-temp)/g[iter-1];
  float bFR=g[iter]/g[iter-1];
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  lin_comb(pv,-1.,ggv,b,pv,nnx*nnz); 
  lin_comb(pvn,-1.,ggvn,b,pvn,nnx*nnz); 
  lin_comb(pvh,-1.,ggvh,b,pvh,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gv;delete []gvn;delete []gvh;
 delete []pv;delete []pvn;delete []pvh;
 delete []ggv;delete []ggvn;delete []ggvh;
 return;
}

