//Following musa1 in sep150
#include <cstdio>
#include <cstdlib>
#include <string.h>
#include "mylib.h"
#include "myio.h"
#include "wave.h"
#include "solvers.h"
#include "helix.h"

void pnlcg01(float *c11,float *c13,float *c33,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gc11=new float[nnx*nnz]();
 float *gc13=new float[nnx*nnz]();
 float *gc33=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient01(datafit[0],reg,gc11,gc13,gc33,d0,c11,c13,c33,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gc11,gc11,nnx*nnz)+dot_product(gc13,gc13,nnx*nnz)+dot_product(gc33,gc33,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *tc11=new float[nnx*nnz](); ns_helixdecon(gc11,tc11,nnx*nnz,aa,lag,na,patch,true);
 float *tc13=new float[nnx*nnz](); ns_helixdecon(gc13,tc13,nnx*nnz,aa,lag,na,patch,true);
 float *tc33=new float[nnx*nnz](); ns_helixdecon(gc33,tc33,nnx*nnz,aa,lag,na,patch,true);
 float *ttc11=new float[nnx*nnz](); ns_helixdecon(ttc11,tc11,nnx*nnz,aa,lag,na,patch,false);
 float *ttc13=new float[nnx*nnz](); ns_helixdecon(ttc13,tc13,nnx*nnz,aa,lag,na,patch,false);
 float *ttc33=new float[nnx*nnz](); ns_helixdecon(ttc33,tc33,nnx*nnz,aa,lag,na,patch,false);

 float *pc11=new float[nnx*nnz](); mynegate(pc11,ttc11,nnx*nnz);
 float *pc13=new float[nnx*nnz](); mynegate(pc13,ttc13,nnx*nnz);
 float *pc33=new float[nnx*nnz](); mynegate(pc33,ttc33,nnx*nnz);
 
 write("ic11",c11,nnx*nnz);
 write("ic13",c13,nnx*nnz);
 write("ic33",c33,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ic11","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic11","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic11","n3",niter,"o3",0.,"d3",1.);
 to_header("ic13","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic13","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic13","n3",niter,"o3",0.,"d3",1.);
 to_header("ic33","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ic33","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ic33","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggc11=new float[nnx*nnz]();
 float *ggc13=new float[nnx*nnz]();
 float *ggc33=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pc11,gc11,nnx*nnz)+dot_product(pc13,gc13,nnx*nnz)+dot_product(pc33,gc33,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   ns_helixdecon(gc11,tc11,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gc13,tc13,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gc33,tc33,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(ttc11,tc11,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttc13,tc13,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttc33,tc33,nnx*nnz,aa,lag,na,patch,false);
   mynegate(pc11,ttc11,nnx*nnz);
   mynegate(pc13,ttc13,nnx*nnz);
   mynegate(pc33,ttc33,nnx*nnz);
  }

  float a=line_search01(c11,c13,c33,f[iter],datafit[iter],ggc11,ggc13,ggc33,f[iter-1],gc11,gc13,gc33,pc11,pc13,pc33,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggc11,ggc11,nnx*nnz)+dot_product(ggc13,ggc13,nnx*nnz)+dot_product(ggc33,ggc33,nnx*nnz);
  
  ns_helixdecon(gc11,tc11,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gc13,tc13,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gc33,tc33,nnx*nnz,aa,lag,na,patch,true);

  ns_helixdecon(ggc11,ttc11,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggc13,ttc13,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggc33,ttc33,nnx*nnz,aa,lag,na,patch,true);

  float temp1=dot_product(ttc11,ttc11,nnx*nnz)+dot_product(ttc13,ttc13,nnx*nnz)+dot_product(ttc33,ttc33,nnx*nnz);
  float temp2=dot_product(tc11,tc11,nnx*nnz)+dot_product(tc13,tc13,nnx*nnz)+dot_product(tc33,tc33,nnx*nnz);
  float temp12=dot_product(ttc11,tc11,nnx*nnz)+dot_product(ttc13,tc13,nnx*nnz)+dot_product(ttc33,tc33,nnx*nnz);

  float bPR=(temp1-temp12)/temp2;
  float bFR=temp1/temp2;
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  ns_helixdecon(tc11,ttc11,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tc13,ttc13,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tc33,ttc33,nnx*nnz,aa,lag,na,patch,false);

  lin_comb(pc11,-1.,tc11,b,pc11,nnx*nnz); 
  lin_comb(pc13,-1.,tc13,b,pc13,nnx*nnz); 
  lin_comb(pc33,-1.,tc33,b,pc33,nnx*nnz); 

  float *pt;
  pt=gc11;gc11=ggc11;ggc11=pt;
  pt=gc13;gc13=ggc13;ggc13=pt;
  pt=gc33;gc33=ggc33;ggc33=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ic11",c11,nnx*nnz,std::ios_base::app);
  write("ic13",c13,nnx*nnz,std::ios_base::app);
  write("ic33",c33,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gc11;delete []gc13;delete []gc33;
 delete []pc11;delete []pc13;delete []pc33;
 delete []ggc11;delete []ggc13;delete []ggc33;
 delete []tc11;delete []tc13;delete []tc33;
 delete []ttc11;delete []ttc13;delete []ttc33;
 return;
}

void pnlcg11(float *v,float *eps,float *del,float v0,float eps0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *geps=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient11(datafit[0],reg,gv,geps,gdel,d0,v,eps,del,v0,eps0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(geps,geps,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *tv=new float[nnx*nnz](); ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
 float *teps=new float[nnx*nnz](); ns_helixdecon(geps,teps,nnx*nnz,aa,lag,na,patch,true);
 float *tdel=new float[nnx*nnz](); ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);
 float *ttv=new float[nnx*nnz](); ns_helixdecon(ttv,tv,nnx*nnz,aa,lag,na,patch,false);
 float *tteps=new float[nnx*nnz](); ns_helixdecon(tteps,teps,nnx*nnz,aa,lag,na,patch,false);
 float *ttdel=new float[nnx*nnz](); ns_helixdecon(ttdel,tdel,nnx*nnz,aa,lag,na,patch,false);

 float *pv=new float[nnx*nnz](); mynegate(pv,ttv,nnx*nnz);
 float *peps=new float[nnx*nnz](); mynegate(peps,tteps,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,ttdel,nnx*nnz);
 
 int n=npad+wbottom/dz+1;
 memset(pv,0,n*nnx*sizeof(float));
 memset(peps,0,n*nnx*sizeof(float));
 memset(pdel,0,n*nnx*sizeof(float));
 
 write("iv",v,nnx*nnz);
 write("ieps",eps,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ieps","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieps","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieps","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggeps=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, datafit %f, grad2 %f\n",iter,f[iter-1],datafit[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(peps,geps,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(geps,teps,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(ttv,tv,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(tteps,teps,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttdel,tdel,nnx*nnz,aa,lag,na,patch,false);
   mynegate(pv,ttv,nnx*nnz);
   mynegate(peps,tteps,nnx*nnz);
   mynegate(pdel,ttdel,nnx*nnz);
   memset(pv,0,n*nnx*sizeof(float));
   memset(peps,0,n*nnx*sizeof(float));
   memset(pdel,0,n*nnx*sizeof(float));
  }

  float a=line_search11(v,eps,del,f[iter],datafit[iter],ggv,ggeps,ggdel,f[iter-1],gv,geps,gdel,pv,peps,pdel,v0,eps0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggeps,ggeps,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(geps,teps,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);

  ns_helixdecon(ggv,ttv,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggeps,tteps,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggdel,ttdel,nnx*nnz,aa,lag,na,patch,true);

  float temp1=dot_product(ttv,ttv,nnx*nnz)+dot_product(tteps,tteps,nnx*nnz)+dot_product(ttdel,ttdel,nnx*nnz);
  float temp2=dot_product(tv,tv,nnx*nnz)+dot_product(teps,teps,nnx*nnz)+dot_product(tdel,tdel,nnx*nnz);
  float temp12=dot_product(ttv,tv,nnx*nnz)+dot_product(tteps,teps,nnx*nnz)+dot_product(ttdel,tdel,nnx*nnz);

  float bPR=(temp1-temp12)/temp2;
  float bFR=temp1/temp2;
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  ns_helixdecon(tv,ttv,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(teps,tteps,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tdel,ttdel,nnx*nnz,aa,lag,na,patch,false);

  lin_comb(pv,-1.,tv,b,pv,nnx*nnz); 
  lin_comb(peps,-1.,teps,b,peps,nnx*nnz); 
  lin_comb(pdel,-1.,tdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=geps;geps=ggeps;ggeps=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ieps",eps,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gv;delete []geps;delete []gdel;
 delete []pv;delete []peps;delete []pdel;
 delete []ggv;delete []ggeps;delete []ggdel;
 delete []tv;delete []teps;delete []tdel;
 delete []ttv;delete []tteps;delete []ttdel;
 return;
}

void pnlcg21(float *vn,float *eta,float *del,float vn0,float eta0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gvn=new float[nnx*nnz]();
 float *geta=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient21(datafit[0],reg,gvn,geta,gdel,d0,vn,eta,del,vn0,eta0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gvn,gvn,nnx*nnz)+dot_product(geta,geta,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *tvn=new float[nnx*nnz](); ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
 float *teta=new float[nnx*nnz](); ns_helixdecon(geta,teta,nnx*nnz,aa,lag,na,patch,true);
 float *tdel=new float[nnx*nnz](); ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);
 float *ttvn=new float[nnx*nnz](); ns_helixdecon(ttvn,tvn,nnx*nnz,aa,lag,na,patch,false);
 float *tteta=new float[nnx*nnz](); ns_helixdecon(tteta,teta,nnx*nnz,aa,lag,na,patch,false);
 float *ttdel=new float[nnx*nnz](); ns_helixdecon(ttdel,tdel,nnx*nnz,aa,lag,na,patch,false);

 float *pvn=new float[nnx*nnz](); mynegate(pvn,ttvn,nnx*nnz);
 float *peta=new float[nnx*nnz](); mynegate(peta,tteta,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,ttdel,nnx*nnz);
 
 write("ivn",vn,nnx*nnz);
 write("ieta",eta,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ieta","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieta","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieta","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvn=new float[nnx*nnz]();
 float *ggeta=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvn,gvn,nnx*nnz)+dot_product(peta,geta,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(geta,teta,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(ttvn,tvn,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(tteta,teta,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttdel,tdel,nnx*nnz,aa,lag,na,patch,false);
   mynegate(pvn,ttvn,nnx*nnz);
   mynegate(peta,tteta,nnx*nnz);
   mynegate(pdel,ttdel,nnx*nnz);
  }

  float a=line_search21(vn,eta,del,f[iter],datafit[iter],ggvn,ggeta,ggdel,f[iter-1],gvn,geta,gdel,pvn,peta,pdel,vn0,eta0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggeta,ggeta,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(geta,teta,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);

  ns_helixdecon(ggvn,ttvn,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggeta,tteta,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggdel,ttdel,nnx*nnz,aa,lag,na,patch,true);

  float temp1=dot_product(ttvn,ttvn,nnx*nnz)+dot_product(tteta,tteta,nnx*nnz)+dot_product(ttdel,ttdel,nnx*nnz);
  float temp2=dot_product(tvn,tvn,nnx*nnz)+dot_product(teta,teta,nnx*nnz)+dot_product(tdel,tdel,nnx*nnz);
  float temp12=dot_product(ttvn,tvn,nnx*nnz)+dot_product(tteta,teta,nnx*nnz)+dot_product(ttdel,tdel,nnx*nnz);

  float bPR=(temp1-temp12)/temp2;
  float bFR=temp1/temp2;
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  ns_helixdecon(tvn,ttvn,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(teta,tteta,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tdel,ttdel,nnx*nnz,aa,lag,na,patch,false);

  lin_comb(pvn,-1.,tvn,b,pvn,nnx*nnz); 
  lin_comb(peta,-1.,teta,b,peta,nnx*nnz); 
  lin_comb(pdel,-1.,tdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=geta;geta=ggeta;ggeta=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ieta",eta,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gvn;delete []geta;delete []gdel;
 delete []pvn;delete []peta;delete []pdel;
 delete []ggvn;delete []ggeta;delete []ggdel;
 delete []tvn;delete []teta;delete []tdel;
 delete []ttvn;delete []tteta;delete []ttdel;
 return;
}

void pnlcg31(float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gvh=new float[nnx*nnz]();
 float *geps=new float[nnx*nnz]();
 float *geta=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient31(datafit[0],reg,gvh,geps,geta,d0,vh,eps,eta,vh0,eps0,eta0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gvh,gvh,nnx*nnz)+dot_product(geps,geps,nnx*nnz)+dot_product(geta,geta,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *tvh=new float[nnx*nnz](); ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
 float *teps=new float[nnx*nnz](); ns_helixdecon(geps,teps,nnx*nnz,aa,lag,na,patch,true);
 float *teta=new float[nnx*nnz](); ns_helixdecon(geta,teta,nnx*nnz,aa,lag,na,patch,true);
 float *ttvh=new float[nnx*nnz](); ns_helixdecon(ttvh,tvh,nnx*nnz,aa,lag,na,patch,false);
 float *tteps=new float[nnx*nnz](); ns_helixdecon(tteps,teps,nnx*nnz,aa,lag,na,patch,false);
 float *tteta=new float[nnx*nnz](); ns_helixdecon(tteta,teta,nnx*nnz,aa,lag,na,patch,false);

 float *pvh=new float[nnx*nnz](); mynegate(pvh,ttvh,nnx*nnz);
 float *peps=new float[nnx*nnz](); mynegate(peps,tteps,nnx*nnz);
 float *peta=new float[nnx*nnz](); mynegate(peta,tteta,nnx*nnz);
 
 write("ivh",vh,nnx*nnz);
 write("ieps",eps,nnx*nnz);
 write("ieta",eta,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("ieps","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieps","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieps","n3",niter,"o3",0.,"d3",1.);
 to_header("ieta","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ieta","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ieta","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvh=new float[nnx*nnz]();
 float *ggeps=new float[nnx*nnz]();
 float *ggeta=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvh,gvh,nnx*nnz)+dot_product(peps,geps,nnx*nnz)+dot_product(peta,geta,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(geps,teps,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(geta,teta,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(ttvh,tvh,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(tteps,teps,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(tteta,teta,nnx*nnz,aa,lag,na,patch,false);
   mynegate(pvh,ttvh,nnx*nnz);
   mynegate(peps,tteps,nnx*nnz);
   mynegate(peta,tteta,nnx*nnz);
  }

  float a=line_search31(vh,eps,eta,f[iter],datafit[iter],ggvh,ggeps,ggeta,f[iter-1],gvh,geps,geta,pvh,peps,peta,vh0,eps0,eta0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggeps,ggeps,nnx*nnz)+dot_product(ggeta,ggeta,nnx*nnz);
  
  ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(geps,teps,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(geta,teta,nnx*nnz,aa,lag,na,patch,true);

  ns_helixdecon(ggvh,ttvh,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggeps,tteps,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggeta,tteta,nnx*nnz,aa,lag,na,patch,true);

  float temp1=dot_product(ttvh,ttvh,nnx*nnz)+dot_product(tteps,tteps,nnx*nnz)+dot_product(tteta,tteta,nnx*nnz);
  float temp2=dot_product(tvh,tvh,nnx*nnz)+dot_product(teps,teps,nnx*nnz)+dot_product(teta,teta,nnx*nnz);
  float temp12=dot_product(ttvh,tvh,nnx*nnz)+dot_product(tteps,teps,nnx*nnz)+dot_product(tteta,teta,nnx*nnz);

  float bPR=(temp1-temp12)/temp2;
  float bFR=temp1/temp2;
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  ns_helixdecon(tvh,ttvh,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(teps,tteps,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(teta,tteta,nnx*nnz,aa,lag,na,patch,false);

  lin_comb(pvh,-1.,tvh,b,pvh,nnx*nnz); 
  lin_comb(peps,-1.,teps,b,peps,nnx*nnz); 
  lin_comb(peta,-1.,teta,b,peta,nnx*nnz); 

  float *pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=geps;geps=ggeps;ggeps=pt;
  pt=geta;geta=ggeta;ggeta=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("ieps",eps,nnx*nnz,std::ios_base::app);
  write("ieta",eta,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gvh;delete []geps;delete []geta;
 delete []pvh;delete []peps;delete []peta;
 delete []ggvh;delete []ggeps;delete []ggeta;
 delete []tvh;delete []teps;delete []teta;
 delete []ttvh;delete []tteps;delete []tteta;
 return;
}

void pnlcg41(float *v,float *vh,float *del,float v0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient41(datafit[0],reg,gv,gvh,gdel,d0,v,vh,del,v0,vh0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *tv=new float[nnx*nnz](); ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
 float *tvh=new float[nnx*nnz](); ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
 float *tdel=new float[nnx*nnz](); ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);
 float *ttv=new float[nnx*nnz](); ns_helixdecon(ttv,tv,nnx*nnz,aa,lag,na,patch,false);
 float *ttvh=new float[nnx*nnz](); ns_helixdecon(ttvh,tvh,nnx*nnz,aa,lag,na,patch,false);
 float *ttdel=new float[nnx*nnz](); ns_helixdecon(ttdel,tdel,nnx*nnz,aa,lag,na,patch,false);

 float *pv=new float[nnx*nnz](); mynegate(pv,ttv,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,ttvh,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,ttdel,nnx*nnz);
 
 write("iv",v,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(ttv,tv,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttvh,tvh,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttdel,tdel,nnx*nnz,aa,lag,na,patch,false);
   mynegate(pv,ttv,nnx*nnz);
   mynegate(pvh,ttvh,nnx*nnz);
   mynegate(pdel,ttdel,nnx*nnz);
  }

  float a=line_search41(v,vh,del,f[iter],datafit[iter],ggv,ggvh,ggdel,f[iter-1],gv,gvh,gdel,pv,pvh,pdel,v0,vh0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);

  ns_helixdecon(ggv,ttv,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggvh,ttvh,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggdel,ttdel,nnx*nnz,aa,lag,na,patch,true);

  float temp1=dot_product(ttv,ttv,nnx*nnz)+dot_product(ttvh,ttvh,nnx*nnz)+dot_product(ttdel,ttdel,nnx*nnz);
  float temp2=dot_product(tv,tv,nnx*nnz)+dot_product(tvh,tvh,nnx*nnz)+dot_product(tdel,tdel,nnx*nnz);
  float temp12=dot_product(ttv,tv,nnx*nnz)+dot_product(ttvh,tvh,nnx*nnz)+dot_product(ttdel,tdel,nnx*nnz);

  float bPR=(temp1-temp12)/temp2;
  float bFR=temp1/temp2;
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  ns_helixdecon(tv,ttv,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tvh,ttvh,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tdel,ttdel,nnx*nnz,aa,lag,na,patch,false);

  lin_comb(pv,-1.,tv,b,pv,nnx*nnz); 
  lin_comb(pvh,-1.,tvh,b,pvh,nnx*nnz); 
  lin_comb(pdel,-1.,tdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gv;delete []gvh;delete []gdel;
 delete []pv;delete []pvh;delete []pdel;
 delete []ggv;delete []ggvh;delete []ggdel;
 delete []tv;delete []tvh;delete []tdel;
 delete []ttv;delete []ttvh;delete []ttdel;
 return;
}

void pnlcg51(float *vn,float *vh,float *del,float vn0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gvn=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 float *gdel=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient51(datafit[0],reg,gvn,gvh,gdel,d0,vn,vh,del,vn0,vh0,del0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gvn,gvn,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz)+dot_product(gdel,gdel,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *tvn=new float[nnx*nnz](); ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
 float *tvh=new float[nnx*nnz](); ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
 float *tdel=new float[nnx*nnz](); ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);
 float *ttvn=new float[nnx*nnz](); ns_helixdecon(ttvn,tvn,nnx*nnz,aa,lag,na,patch,false);
 float *ttvh=new float[nnx*nnz](); ns_helixdecon(ttvh,tvh,nnx*nnz,aa,lag,na,patch,false);
 float *ttdel=new float[nnx*nnz](); ns_helixdecon(ttdel,tdel,nnx*nnz,aa,lag,na,patch,false);

 float *pvn=new float[nnx*nnz](); mynegate(pvn,ttvn,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,ttvh,nnx*nnz);
 float *pdel=new float[nnx*nnz](); mynegate(pdel,ttdel,nnx*nnz);
 
 write("ivn",vn,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("idel",del,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("idel","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("idel","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("idel","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggvn=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();
 float *ggdel=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pvn,gvn,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz)+dot_product(pdel,gdel,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(ttvn,tvn,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttvh,tvh,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttdel,tdel,nnx*nnz,aa,lag,na,patch,false);
   mynegate(pvn,ttvn,nnx*nnz);
   mynegate(pvh,ttvh,nnx*nnz);
   mynegate(pdel,ttdel,nnx*nnz);
  }

  float a=line_search51(vn,vh,del,f[iter],datafit[iter],ggvn,ggvh,ggdel,f[iter-1],gvn,gvh,gdel,pvn,pvh,pdel,vn0,vh0,del0,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz)+dot_product(ggdel,ggdel,nnx*nnz);
  
  ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gdel,tdel,nnx*nnz,aa,lag,na,patch,true);

  ns_helixdecon(ggvn,ttvn,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggvh,ttvh,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggdel,ttdel,nnx*nnz,aa,lag,na,patch,true);

  float temp1=dot_product(ttvn,ttvn,nnx*nnz)+dot_product(ttvh,ttvh,nnx*nnz)+dot_product(ttdel,ttdel,nnx*nnz);
  float temp2=dot_product(tvn,tvn,nnx*nnz)+dot_product(tvh,tvh,nnx*nnz)+dot_product(tdel,tdel,nnx*nnz);
  float temp12=dot_product(ttvn,tvn,nnx*nnz)+dot_product(ttvh,tvh,nnx*nnz)+dot_product(ttdel,tdel,nnx*nnz);

  float bPR=(temp1-temp12)/temp2;
  float bFR=temp1/temp2;
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  ns_helixdecon(tvn,ttvn,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tvh,ttvh,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tdel,ttdel,nnx*nnz,aa,lag,na,patch,false);

  lin_comb(pvn,-1.,tvn,b,pvn,nnx*nnz); 
  lin_comb(pvh,-1.,tvh,b,pvh,nnx*nnz); 
  lin_comb(pdel,-1.,tdel,b,pdel,nnx*nnz); 

  float *pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;
  pt=gdel;gdel=ggdel;ggdel=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("idel",del,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gvn;delete []gvh;delete []gdel;
 delete []pvn;delete []pvh;delete []pdel;
 delete []ggvn;delete []ggvh;delete []ggdel;
 delete []tvn;delete []tvh;delete []tdel;
 delete []ttvn;delete []ttvh;delete []ttdel;
 return;
}

void pnlcg61(float *v,float *vn,float *vh,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *f=new float[niter]();
 float *datafit=new float[niter]();
 float reg;
 float *g=new float[niter]();

 float *gv=new float[nnx*nnz]();
 float *gvn=new float[nnx*nnz]();
 float *gvh=new float[nnx*nnz]();
 
 float *m=new float[nnx*nnz]();

 f[0]=objFuncGradient61(datafit[0],reg,gv,gvn,gvh,d0,v,vn,vh,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
 
 g[0]=dot_product(gv,gv,nnx*nnz)+dot_product(gvn,gvn,nnx*nnz)+dot_product(gvh,gvh,nnx*nnz);

 write("objfunc",f,1);
 to_header("objfunc","n1",niter,"o1",0.,"d1",1.);
 
 write("datafit",datafit,1);
 to_header("datafit","n1",niter,"o1",0.,"d1",1.);
 
 write("normg2",g,1);
 to_header("normg2","n1",niter,"o1",0.,"d1",1.);
 
 write("steplength",&a0,1);
 to_header("steplength","n1",niter,"o1",0.,"d1",1.);
 
 float *tv=new float[nnx*nnz](); ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
 float *tvn=new float[nnx*nnz](); ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
 float *tvh=new float[nnx*nnz](); ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
 float *ttv=new float[nnx*nnz](); ns_helixdecon(ttv,tv,nnx*nnz,aa,lag,na,patch,false);
 float *ttvn=new float[nnx*nnz](); ns_helixdecon(ttvn,tvn,nnx*nnz,aa,lag,na,patch,false);
 float *ttvh=new float[nnx*nnz](); ns_helixdecon(ttvh,tvh,nnx*nnz,aa,lag,na,patch,false);

 float *pv=new float[nnx*nnz](); mynegate(pv,ttv,nnx*nnz);
 float *pvn=new float[nnx*nnz](); mynegate(pvn,ttvn,nnx*nnz);
 float *pvh=new float[nnx*nnz](); mynegate(pvh,ttvh,nnx*nnz);
 
 write("iv",v,nnx*nnz);
 write("ivn",vn,nnx*nnz);
 write("ivh",vh,nnx*nnz);
 write("check",m,nnx*nnz);

 to_header("iv","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("iv","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("iv","n3",niter,"o3",0.,"d3",1.);
 to_header("ivn","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivn","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivn","n3",niter,"o3",0.,"d3",1.);
 to_header("ivh","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("ivh","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("ivh","n3",niter,"o3",0.,"d3",1.);
 to_header("check","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("check","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("check","n3",niter,"o3",0.,"d3",1.);

 float *ggv=new float[nnx*nnz]();
 float *ggvn=new float[nnx*nnz]();
 float *ggvh=new float[nnx*nnz]();

 for(int iter=1;iter<niter;++iter){
  fprintf(stderr,"iteration %d, obj func %f, grad2 %f\n",iter,f[iter-1],g[iter-1]);

  float pTg=dot_product(pv,gv,nnx*nnz)+dot_product(pvn,gvn,nnx*nnz)+dot_product(pvh,gvh,nnx*nnz);
  if(pTg>=0.){
   fprintf(stderr,"Search direction is not a decent direction. Take steepest decent.\n");
   ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);
   ns_helixdecon(ttv,tv,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttvn,tvn,nnx*nnz,aa,lag,na,patch,false);
   ns_helixdecon(ttvh,tvh,nnx*nnz,aa,lag,na,patch,false);
   mynegate(pv,ttv,nnx*nnz);
   mynegate(pvn,ttvn,nnx*nnz);
   mynegate(pvh,ttvh,nnx*nnz);
  }

  float a=line_search61(v,vn,vh,f[iter],datafit[iter],ggv,ggvn,ggvh,f[iter-1],gv,gvn,gvh,pv,pvn,pvh,a0,d0,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate,wbottom,m,alpha,aa,lag,na,patch);
  a0=a;
  fprintf(stderr,"step length %f\n",a);
  write("steplength",&a,1,std::ios_base::app);

  g[iter]=dot_product(ggv,ggv,nnx*nnz)+dot_product(ggvn,ggvn,nnx*nnz)+dot_product(ggvh,ggvh,nnx*nnz);
  
  ns_helixdecon(gv,tv,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gvn,tvn,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(gvh,tvh,nnx*nnz,aa,lag,na,patch,true);

  ns_helixdecon(ggv,ttv,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggvn,ttvn,nnx*nnz,aa,lag,na,patch,true);
  ns_helixdecon(ggvh,ttvh,nnx*nnz,aa,lag,na,patch,true);

  float temp1=dot_product(ttv,ttv,nnx*nnz)+dot_product(ttvn,ttvn,nnx*nnz)+dot_product(ttvh,ttvh,nnx*nnz);
  float temp2=dot_product(tv,tv,nnx*nnz)+dot_product(tvn,tvn,nnx*nnz)+dot_product(tvh,tvh,nnx*nnz);
  float temp12=dot_product(ttv,tv,nnx*nnz)+dot_product(ttvn,tvn,nnx*nnz)+dot_product(ttvh,tvh,nnx*nnz);

  float bPR=(temp1-temp12)/temp2;
  float bFR=temp1/temp2;
  float b;
  if(bPR<-bFR) b=-bFR;
  else if(bPR>bFR) b=bFR;
  else b=bPR;
  fprintf(stderr,"b %f\n",b);

  ns_helixdecon(tv,ttv,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tvn,ttvn,nnx*nnz,aa,lag,na,patch,false);
  ns_helixdecon(tvh,ttvh,nnx*nnz,aa,lag,na,patch,false);

  lin_comb(pv,-1.,tv,b,pv,nnx*nnz); 
  lin_comb(pvn,-1.,tvn,b,pvn,nnx*nnz); 
  lin_comb(pvh,-1.,tvh,b,pvh,nnx*nnz); 

  float *pt;
  pt=gv;gv=ggv;ggv=pt;
  pt=gvn;gvn=ggvn;ggvn=pt;
  pt=gvh;gvh=ggvh;ggvh=pt;

  write("objfunc",f+iter,1,std::ios_base::app);
  write("datafit",datafit+iter,1,std::ios_base::app);
  write("normg2",g+iter,1,std::ios_base::app);
  
  write("iv",v,nnx*nnz,std::ios_base::app);
  write("ivn",vn,nnx*nnz,std::ios_base::app);
  write("ivh",vh,nnx*nnz,std::ios_base::app);
  write("check",m,nnx*nnz,std::ios_base::app);
 }
 
 delete []f;delete []datafit;delete []g;
 delete[] m;
 delete []gv;delete []gvn;delete []gvh;
 delete []pv;delete []pvn;delete []pvh;
 delete []ggv;delete []ggvn;delete []ggvh;
 delete []tv;delete []tvn;delete []tvh;
 delete []ttv;delete []ttvn;delete []ttvh;
 return;
}

