#ifndef SOLVERS_H
#define SOLVERS_H

#define NITER_LS 5
#define NITER_ZOOM 10
#define NITER_CG 1000 

const float c1=1e-2;
const float c2=0.8;

void nlcg0(float *c11,float *c13,float *c33,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom);

float line_search0(float *c11,float *c13,float *c33,float &f,float *ggc11,float *gcc13,float *ggc33,float f0,const float *gc11,const float *gc13,const float *gc33,const float *pc11,const float *pc13,const float *pc33,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float zoom0(float *c11,float *c13,float *c33,float &f,float *ggc11,float *ggc13,float *ggc33,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pc11,const float *pc13,const float *pc33,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

void nlcg01(float *c11,float *c13,float *c33,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

void pnlcg01(float *c11,float *c13,float *c33,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

float line_search01(float *c11,float *c13,float *c33,float &f,float &datafit,float *ggc11,float *ggc13,float *ggc33,float f0,const float *gc11,const float *gc13,const float *gc33,const float *pc11,const float *pc13,const float *pc33,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float zoom01(float *c11,float *c13,float *c33,float &f,float &datafit,float *ggc11,float *ggc13,float *ggc33,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pc11,const float *pc13,const float *pc33,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

void nlcg1(float *v,float *eps,float *del,float v0,float eps0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom);

float line_search1(float *v,float *eps,float *del,float &f,float *ggv,float *ggeps,float *ggdel,float f0,const float *gv,const float *geps,const float *gdel,const float *pv,const float *peps,const float *pdel,float v0,float eps0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float zoom1(float *v,float *eps,float *del,float &f,float *ggv,float *ggeps,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pv,const float *peps,const float *pdel,float v0,float eps0,float del0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

void nlcg11(float *v,float *eps,float *del,float v0,float eps0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

void pnlcg11(float *v,float *eps,float *del,float v0,float eps0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

float line_search11(float *v,float *eps,float *del,float &f,float &datafit,float *ggv,float *ggeps,float *ggdel,float f0,const float *gv,const float *geps,const float *gdel,const float *pv,const float *peps,const float *pdel,float v0,float eps0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float zoom11(float *v,float *eps,float *del,float &f,float &datafit,float *ggv,float *ggeps,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pv,const float *peps,const float *pdel,float v0,float eps0,float del0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

void nlcg2(float *vn,float *eta,float *del,float vn0,float eta0,float del0,int niter,float a0,const float *d0,const float *wavnelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom);

float line_search2(float *vn,float *eta,float *del,float &f,float *ggvn,float *ggeta,float *ggdel,float f0,const float *gvn,const float *geta,const float *gdel,const float *pvn,const float *peta,const float *pdel,float vn0,float eta0,float del0,float a0,const float *d0,const float *wavnelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float zoom2(float *vn,float *eta,float *del,float &f,float *ggvn,float *ggeta,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pvn,const float *peta,const float *pdel,float vn0,float eta0,float del0,const float *d0,const float *wavnelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

void nlcg21(float *vn,float *eta,float *del,float vn0,float eta0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

void pnlcg21(float *vn,float *eta,float *del,float vn0,float eta0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

float line_search21(float *vn,float *eta,float *del,float &f,float &datafit,float *ggvn,float *ggeta,float *ggdel,float f0,const float *gvn,const float *geta,const float *gdel,const float *pvn,const float *peta,const float *pdel,float vn0,float eta0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float zoom21(float *vn,float *eta,float *del,float &f,float &datafit,float *ggvn,float *ggeta,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pvn,const float *peta,const float *pdel,float vn0,float eta0,float del0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

void nlcg3(float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,int niter,float a0,const float *d0,const float *wavhelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom);

float line_search3(float *vh,float *eps,float *eta,float &f,float *ggvh,float *ggeps,float *ggeta,float f0,const float *gvh,const float *geps,const float *geta,const float *pvh,const float *peps,const float *peta,float vh0,float eps0,float eta0,float a0,const float *d0,const float *wavhelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float zoom3(float *vh,float *eps,float *eta,float &f,float *ggvh,float *ggeps,float *ggeta,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pvh,const float *peps,const float *peta,float vh0,float eps0,float eta0,const float *d0,const float *wavhelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

void pnlcg31(float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

void nlcg31(float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

float line_search31(float *vh,float *eps,float *eta,float &f,float &datafit,float *ggvh,float *ggeps,float *ggeta,float f0,const float *gvh,const float *geps,const float *geta,const float *pvh,const float *peps,const float *peta,float vh0,float eps0,float eta0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float zoom31(float *vh,float *eps,float *eta,float &f,float &datafit,float *ggvh,float *ggeps,float *ggeta,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pvh,const float *peps,const float *peta,float vh0,float eps0,float eta0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

void nlcg4(float *v,float *vh,float *del,float v0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom);

float line_search4(float *v,float *vh,float *del,float &f,float *ggv,float *ggvh,float *ggdel,float f0,const float *gv,const float *gvh,const float *gdel,const float *pv,const float *pvh,const float *pdel,float v0,float vh0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float zoom4(float *v,float *vh,float *del,float &f,float *ggv,float *ggvh,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pv,const float *pvh,const float *pdel,float v0,float vh0,float del0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

void nlcg41(float *v,float *vh,float *del,float v0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

void pnlcg41(float *v,float *vh,float *del,float v0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

float line_search41(float *v,float *vh,float *del,float &f,float &datafit,float *ggv,float *ggvh,float *ggdel,float f0,const float *gv,const float *gvh,const float *gdel,const float *pv,const float *pvh,const float *pdel,float v0,float vh0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float zoom41(float *v,float *vh,float *del,float &f,float &datafit,float *ggv,float *ggvh,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pv,const float *pvh,const float *pdel,float v0,float vh0,float del0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

void nlcg5(float *vn,float *vh,float *del,float vn0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom);

float line_search5(float *vn,float *vh,float *del,float &f,float *ggvn,float *ggvh,float *ggdel,float f0,const float *gvn,const float *gvh,const float *gdel,const float *pvn,const float *pvh,const float *pdel,float vn0,float vh0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float zoom5(float *vn,float *vh,float *del,float &f,float *ggvn,float *ggvh,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pvn,const float *pvh,const float *pdel,float vn0,float vh0,float del0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

void nlcg51(float *vn,float *vh,float *del,float vn0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

void pnlcg51(float *vn,float *vh,float *del,float vn0,float vh0,float del0,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

float line_search51(float *vn,float *vh,float *del,float &f,float &datafit,float *ggvn,float *ggvh,float *ggdel,float f0,const float *gvn,const float *gvh,const float *gdel,const float *pvn,const float *pvh,const float *pdel,float vn0,float vh0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float zoom51(float *vn,float *vh,float *del,float &f,float &datafit,float *ggvn,float *ggvh,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pvn,const float *pvh,const float *pdel,float vn0,float vh0,float del0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

void nlcg6(float *v,float *vn,float *vh,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom);

float line_search6(float *v,float *vn,float *vh,float &f,float *ggv,float *ggvn,float *ggvh,float f0,const float *gv,const float *gvn,const float *gvh,const float *pv,const float *pvn,const float *pvh,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float zoom6(float *v,float *vn,float *vh,float &f,float *ggv,float *ggvn,float *ggvh,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pv,const float *pvn,const float *pvh,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

void nlcg61(float *v,float *vn,float *vh,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

void pnlcg61(float *v,float *vn,float *vh,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float alpha,float **aa,int **lag,int *na,int *patch);

float line_search61(float *v,float *vn,float *vh,float &f,float &datafit,float *ggv,float *ggvn,float *ggvh,float f0,const float *gv,const float *gvn,const float *gvh,const float *pv,const float *pvn,const float *pvh,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float zoom61(float *v,float *vn,float *vh,float &f,float &datafit,float *ggv,float *ggvn,float *ggvh,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pv,const float *pvn,const float *pvh,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

#endif
