#include <iostream>
#include <math.h>
#include "myio.h"
#include "mylib.h"

using namespace std;

int main(int argc,char **argv){
 myio_init(argc,argv);
 int nx,nz;
 float dx,dz;
 get_param("nx",nx);
 get_param("nz",nz);
 get_param("dx",dx);
 get_param("dz",dz);
 float *c11=new float[nx*nz]();
 float *c13=new float[nx*nz]();
 float *c33=new float[nx*nz]();
 read("c11",c11,nx*nz); scale(c11,c11,1e-6,nx*nz);
 read("c13",c13,nx*nz); scale(c13,c13,1e-6,nx*nz);
 read("c33",c33,nx*nz); scale(c33,c33,1e-6,nx*nz);
 
 int count1=0,count2=0,count3=0;
 for(int ix=0;ix<nx;++ix){
  for(int iz=0;iz<nz;++iz){
   if(c11[ix+iz*nx]<0.) count1+=1;
   if(c33[ix+iz*nx]<0.) count3+=1;
   if(c11[ix+iz*nx]*c33[ix+iz*nx]<c13[ix+iz*nx]*c13[ix+iz*nx]){
    count2+=1;
	c13[ix+iz*nx]=0.99*sqrt(fabs(c11[ix+iz*nx]*c33[ix+iz*nx]));
   }
  }
 }
 cout<<"First check"<<endl;
 cout<<"Condition c11>=0 not satisfied at "<<count1<<" points"<<endl;
 cout<<"Condition c33>=0 not satisfied at "<<count3<<" points"<<endl;
 cout<<"Condition c11*c33>=c13^2 not satisfied at "<<count2<<" points"<<endl;
 count1=0;count2=0;
 for(int ix=0;ix<nx;++ix){
  for(int iz=0;iz<nz;++iz){
   if(c11[ix+iz*nx]<0.) count1+=1;
   if(c11[ix+iz*nx]*c33[ix+iz*nx]<c13[ix+iz*nx]*c13[ix+iz*nx]){
    count2+=1;
	c13[ix+iz*nx]=sqrt(fabs(c11[ix+iz*nx]*c33[ix+iz*nx]));
   }
  }
 }
 cout<<"Second check"<<endl;
 cout<<"Condition c11>=0 not satisfied at "<<count1<<" points"<<endl;
 cout<<"Condition c11*c33>=c13^2 not satisfied at "<<count2<<" points"<<endl;
 count1=0;count2=0;
 for(int ix=0;ix<nx;++ix){
  for(int iz=0;iz<nz;++iz){
   if(c11[ix+iz*nx]<0.) count1+=1;
   if(c11[ix+iz*nx]*c33[ix+iz*nx]<c13[ix+iz*nx]*c13[ix+iz*nx]){
    count2+=1;
	c13[ix+iz*nx]=sqrt(fabs(c11[ix+iz*nx]*c33[ix+iz*nx]));
   }
  }
 }
 cout<<" check"<<endl;
 cout<<"Condition c11>=0 not satisfied at "<<count1<<" points"<<endl;
 cout<<"Condition c11*c33>=c13^2 not satisfied at "<<count2<<" points"<<endl;
 if(count2>0){
  write("nc13",c13,nx*nz);
  to_header("nc13","n1",nx,"o1",0.,"d1",dx);
  to_header("nc13","n2",nz,"o1",0.,"d2",dz);
 }
 delete []c11; delete []c13;delete []c33;
 myio_close();
 return 0;
}
