#include <iostream>
#include "myio.h"
#include "mylib.h"

using namespace std;

int main(int argc,char **argv){
 myio_init(argc,argv);
 int nx,nz;
 get_param("nx",nx);
 get_param("nz",nz);
 float *eps=new float[nx*nz]();
 float *del=new float[nx*nz]();
 read("eps",eps,nx*nz);
 read("del",del,nx*nz);
 int s=0;
 for(int ix=0;ix<nx;++ix){
  for(int iz=0;iz<nz;++iz){
   if(eps[ix+iz*nx]<del[ix+iz*nx]){
    s=1;
    eps[ix+iz*nx]=del[ix+iz*nx];
   }
  }
 }
 if(s==0){
 cout<<"Stable"<<endl;
 }
 else{
 cout<<"Unstable"<<endl;
 write("neps",eps,nx*nz);
 to_header("neps","n1",nx,"o1",0.,"d1",12.5);
 to_header("neps","n2",nz,"o1",0.,"d2",12.5);
 }
 delete []eps; delete []del;
 myio_close();
 return 0;
}
