#ifndef WAVE_H
#define WAVE_H

void synthetic_f(float *d,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void rtm_f(float *image,const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

float objFunc0(const float *d0,float *c11,float *c13,float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m);

float objFunc01(float &datafit,float &reg,const float *d0,float *c11,float *c13,float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFunc1(const float *d0,float *v,float *eps,float *del,float v0,float eps0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m);

float objFunc11(float &datafit,float &reg,const float *d0,float *v,float *eps,float *del,float v0,float eps0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFunc2(const float *d0,float *vn,float *eta,float *del,float vn0,float eta0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m);

float objFunc21(float &datafit,float &reg,const float *d0,float *vn,float *eta,float *del,float vn0,float eta0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFunc3(const float *d0,float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m);

float objFunc31(float &datafit,float &reg,const float *d0,float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFunc4(const float *d0,float *v,float *vh,float *del,float v0,float vh0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m);

float objFunc41(float &datafit,float &reg,const float *d0,float *v,float *vh,float *del,float v0,float vh0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFunc5(const float *d0,float *vn,float *vh,float *del,float vn0,float vh0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m);

float objFunc51(float &datafit,float &reg,const float *d0,float *vn,float *vh,float *del,float vn0,float vh0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFunc6(const float *d0,float *v,float *vn,float *vh,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m);

float objFunc61(float &datafit,float &reg,const float *d0,float *v,float *vn,float *vh,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFunc_f(const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

float objFuncGradient0(float *gc11,float *gc13,float *gc33,const float *d0,float *c11,float *c13,float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float objFuncGradient01(float &datafit,float &reg,float *gc11,float *gc13,float *gc33,const float *d0,float *c11,float *c13,float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFuncGradient1(float *gv,float *geps,float *gdel,const float *d0,float *v,float *eps,float *del,float v0,float eps0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float objFuncGradient11(float &datafit,float &reg,float *gv,float *geps,float *gdel,const float *d0,float *v,float *eps,float *del,float v0,float eps0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFuncGradient2(float *gvn,float *geta,float *gdel,const float *d0,float *vn,float *eta,float *del,float vn0,float eta0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float objFuncGradient21(float &datafit,float &reg,float *gvn,float *geta,float *gdel,const float *d0,float *vn,float *eta,float *del,float vn0,float eta0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFuncGradient3(float *gvh,float *geps,float *geta,const float *d0,float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float objFuncGradient31(float &datafit,float &reg,float *gvh,float *geps,float *geta,const float *d0,float *vh,float *eps,float *eta,float vh0,float eps0,float eta0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFuncGradient4(float *gv,float *gvh,float *gdel,const float *d0,float *v,float *vh,float *del,float v0,float vh0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float objFuncGradient41(float &datafit,float &reg,float *gv,float *gvh,float *gdel,const float *d0,float *v,float *vh,float *del,float v0,float vh0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFuncGradient5(float *gvn,float *gvh,float *gdel,const float *d0,float *vn,float *vh,float *del,float vn0,float vh0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float objFuncGradient51(float &datafit,float &reg,float *gvn,float *gvh,float *gdel,const float *d0,float *vn,float *vh,float *del,float vn0,float vh0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFuncGradient6(float *gv,float *gvn,float *gvh,const float *d0,float *v,float *vn,float *vh,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m);

float objFuncGradient61(float &datafit,float &reg,float *gv,float *gvn,float *gvh,const float *d0,float *v,float *vn,float *vh,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float wbottom,float *m,float alpha,float **aa,int **lag,int *na,int *patch);

float objFuncGradient_f(float *gc11,float *gc13,float *gc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void modeling_f(float *d,const float *c11,const float *c13,const float *c33,const float *wavelet,int slocxz,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

#endif
